/*
When you and I were training I saw you used DCBDEBUG. in a way that you
could click on the app and the browse would refresh with the callstack
information listing appearing immediately.

How would I use DCBDEBUG to do that?

I am trying to inspect gui elements of an app and am unfamiliar with the
code. Thanks!
*/

#INCLUDE "dcdialog.CH"
#INCLUDE "appevent.ch"

#Pragma Library("dclipx.lib")
#Pragma Library("dclip1.lib")

FUNCTION Main()

LOCAL GetList[0], aGets[20], oTab1, oTab2, GetOptions, oGet7, oDlg, ;
      oBrowse, aDir := Directory(), nRadio := 1, nRadio2 := 2, oGetGroup

AFill(aGets,20)

@ 0,0 DCTABPAGE oTab1 CAPTION 'Tab 1' SIZE 700, 400 ID 'TAB1'
@ 0,0 DCTABPAGE oTab2 CAPTION 'Tab 2' RELATIVE oTab1 ID 'TAB2'

@ 36,30 DCGROUP oGetGroup CAPTION 'Get Group' ;
         WIDTH 529 ;
         HEIGHT 282 ;
         PARENTID 'TAB1';
         ID 'GETGROUP'

@ 80,56 DCSAY 'Get 1'  GET aGets[1]  PARENTID 'GETGROUP' POPUP {|c|c} SAYSIZE 50, 20
@ 48,328 DCSAY 'Get 2'  GET aGets[2]  PARENTID 'GETGROUP' SAYSIZE 50, 20
@ 196,55 DCSAY 'Get 3'  GET aGets[3]  PARENTID 'GETGROUP' POPUP {|c|c} SAYSIZE 50, 20
@ 82,330 DCSAY 'Get 4'  GET aGets[4]  PARENTID 'GETGROUP' SAYSIZE 50, 20
@ 156,57 DCSAY 'Get 5'  GET aGets[5]  PARENTID 'GETGROUP' WHEN {||.f.}
@ 255,373 DCSAY 'Get 6'  GET aGets[6]  PARENTID 'GETGROUP'
@ 134,330 DCSAY 'Get 7'  GET aGets[7]  PARENTID 'GETGROUP' GETOBJECT oGet7
@ 161,330 DCSAY 'Get 8'  GET aGets[8]  PARENTID 'GETGROUP'
@ 187,330 DCSAY 'Get 9'  GET aGets[9]  PARENTID 'GETGROUP'
@ 44,59 DCSAY 'Get 10' GET aGets[10] PARENTID 'GETGROUP' SAYSIZE 50, 20

@ 365,21 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 300,20 ID 'RADIO_STATIC' PARENTID 'TAB1'
@ 0,0 DCRADIO nRadio PARENTID 'RADIO_STATIC' PROMPT 'Radio 1' VALUE 1
@ 0,100 DCRADIO nRadio PARENTID 'RADIO_STATIC' PROMPT 'Radio 2' VALUE 2
@ 0,200 DCRADIO nRadio PARENTID 'RADIO_STATIC' PROMPT 'Radio 3' VALUE 3

@ 343,21 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 300,20 ID 'RADIO_STATIC2' PARENTID 'TAB1'
@ 0,0 DCRADIO nRadio2 PARENTID 'RADIO_STATIC2' PROMPT 'Radio 1' VALUE 1
@ 0,100 DCRADIO nRadio2 PARENTID 'RADIO_STATIC2' PROMPT 'Radio 2' VALUE 2
@ 0,200 DCRADIO nRadio2 PARENTID 'RADIO_STATIC2' PROMPT 'Radio 3' VALUE 3

@ 40,20 DCPUSHBUTTON CAPTION 'Nothing' SIZE 156, 038.00 ;
          ACTION {||(wtf 'I am nothing')} PARENTID 'TAB2'

@ 038.00,380 DCBROWSE oBrowse DATA aDir SIZE 300,344.00 PARENTID 'TAB2' HEADLINES 2

DCBROWSECOL ELEMENT 1 HEADER 'File Name' WIDTH 100 PARENT oBrowse
DCBROWSECOL ELEMENT 2 HEADER 'File Size' WIDTH 100 PARENT oBrowse

DC_Sett('EDITOR','Q.BAT')  // <<<<<<<<
DebugConfig()              // <<<<<<<<
DC_ReadGuiHandler({|a,b,c,d,e,f|DebugHandler(a,b,c,d,e,f)}) // <<<<<<<<

DCGETOPTIONS ;
   PIXEL ;
   SAYWIDTH 50 ;
   SAYRIGHTBOTTOM ;
   SOURCEFILE __FILEPATH__ // <<<<<<<<

DCREAD GUI FIT TITLE 'Debug Sample' OPTIONS GetOptions PaRENT @oDlg

RETURN nil

* -------------

PROC appsys
RETURN

* -----------

STATIC FUNCTION DebugConfig()

LOCAL aConfig := { ;
   {'Row', ;
    'b', ;
    'Object Name', ;
    Chr(255), ;
    Chr(255), ;
    'Object;Proc' }, ;
   { 5, ;
     2, ;
     20, ;
     1, ;
     1, ;
     13 }, ;
   { nil, ;
     .f., ;
     nil, ;
     nil, ;
     nil, ;
     {||ProcInfo()} } }

DC_DebugBrowseConfig(2,aConfig)

RETURN nil

* -----------

FUNCTION DebugHandler( nEvent, mp1, mp2, oXbp, oDlg, GetList )

LOCAL aProc

IF nEvent == xbeM_LbClick
  DO WHILE Valtype(oXbp) == 'O'
    aProc := DC_GetProperty( oXbp, aGETLIST_PROC )
    IF Valtype(aProc) == 'A'
      IF Upper(aProc[1]) = 'DC_DEBUGWINDOWBROWSE'
        EXIT
      ENDIF
      ProcInfo( aProc[1] + '(' + Alltrim(Str(aProc[2])) + ')' )
      WTF oXbp WINDOW 2
      EXIT
    ENDIF
    oXbp := oXbp:setParent()
  ENDDO
ENDIF

RETURN DCGUI_NONE

* ------------

GETSETFUNCTION ProcInfo DEFAULT ''


